/* 
* MCP2515.cpp
*
* Created: 5.2.2014 19:53:58
* Author: MTV
*/


#include "MCP2515.h"
#include "wait.h"
#include "fifo.h"

//spi_select_class spi(&DDRB, &PORTB, PB4);


// default constructor
MCP2515::MCP2515(spi_class &spi): spi(spi)
{
	//spi_ini();
	//reset();
} //MCP2515

// default destructor
MCP2515::~MCP2515()
{
} //~MCP2515

//Inizializace SPI rozhrani
void MCP2515::spi_ini(void)
{
	spi.set_operating_mode(spi.MASTER);
	spi.enable_SPI();
	spi.set_data_order(spi.MSB);	
	spi.set_data_mode(spi.DATA_MODE_0);
	spi.set_clock_rate(spi.F_OSC_2);
} //void spi_ini(void)

//////////////////////////////////////////////////////////////////////////
/////////////////////////////Inicializace/////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void MCP2515::set_baudrate(uint8_t CNF1_val, uint8_t CNF2_val, uint8_t CNF3_val)
{
	spi.select(true);
	
	spi.write_data(SPI_WRITE);
	spi.write_data(CNF3);
	spi.write_data(CNF3_val);
	spi.write_data(CNF2_val);
	spi.write_data(CNF1_val);
	
	spi.select(false);
} //void set_baudrate(uint8_t CNF1_val, uint8_t CNF3_val, uint8_t CNF2_val)

void MCP2515::set_RX0BF_pin(uint8_t mode)
{
		 if (mode == RX_BUFFER_FULL_IRQ) modify_bit(BFPCTRL, (1<<B0BFE) | (1<<B0BFM) |(1<<B0BFS), (1<<B0BFE) | (1<<B0BFM));
	else if (mode == DIGITAL_OUTPUT)	 modify_bit(BFPCTRL, (1<<B0BFE) | (1<<B0BFM) |(1<<B0BFS), (1<<B0BFE));
	else if (mode == ON)				 modify_bit(BFPCTRL, (1<<B0BFE) | (1<<B0BFM) |(1<<B0BFS), (1<<B0BFE));
	else if (mode == OFF)				 modify_bit(BFPCTRL, (1<<B0BFE) | (1<<B0BFM) |(1<<B0BFS), (1<<B0BFE) | (1<<B0BFS));
	else modify_bit(BFPCTRL, (1<<B0BFE) | (1<<B0BFM) |(1<<B0BFS), 0);	//DISABLED
} //void set_RX0BF_pin(uint8_t mode)

void MCP2515::set_RX1BF_pin(uint8_t mode)
{
		  if (mode == RX_BUFFER_FULL_IRQ) modify_bit(BFPCTRL, (1<<B1BFE) | (1<<B1BFM) |(1<<B1BFS), (1<<B1BFE) | (1<<B1BFM));
	 else if (mode == DIGITAL_OUTPUT)     modify_bit(BFPCTRL, (1<<B1BFE) | (1<<B1BFM) |(1<<B1BFS), (1<<B1BFE));
	 else if (mode == ON)				  modify_bit(BFPCTRL, (1<<B1BFE) | (1<<B1BFM) |(1<<B1BFS), (1<<B1BFE));
	 else if (mode == OFF)				  modify_bit(BFPCTRL, (1<<B1BFE) | (1<<B1BFM) |(1<<B1BFS), (1<<B1BFE) | (1<<B1BFS));
	 else modify_bit(BFPCTRL, (1<<B1BFE) | (1<<B1BFM) |(1<<B1BFS), 0);	//DISABLED	
} //void set_RX1BF_pin(uint8_t mode)

void MCP2515::set_CLKOUT_pin(uint8_t state, uint8_t prescaler /* = PRESCALER_8 */)
{
	if (state == CLKOUT_DISABLE) modify_bit(CANCTRL, (1<<CLKEN), 0);
	else if (prescaler == PRESCALER_1) modify_bit(CANCTRL, (1<<CLKEN) | (1<<CLKPRE0) | (1<<CLKPRE1), (1<<CLKEN));
	else if (prescaler == PRESCALER_2) modify_bit(CANCTRL, (1<<CLKEN) | (1<<CLKPRE0) | (1<<CLKPRE1), (1<<CLKEN) | (1<<CLKPRE0));
	else if (prescaler == PRESCALER_4) modify_bit(CANCTRL, (1<<CLKEN) | (1<<CLKPRE0) | (1<<CLKPRE1), (1<<CLKEN) | (1<<CLKPRE1));
	else if (prescaler == PRESCALER_8) modify_bit(CANCTRL, (1<<CLKEN) | (1<<CLKPRE0) | (1<<CLKPRE1), (1<<CLKEN) | (1<<CLKPRE1) | (1<<CLKPRE0));
	else modify_bit(CANCTRL, (1<<CLKEN), 0);	
} //void set_CLKOUT_pin(uint8_t state, uint8_t prescaler /* = PRESCALER_8 */)

void MCP2515::set_operating_mode(uint8_t mode)
{
		 if (mode == NORMAL_MODE)		modify_bit(CANCTRL, 0xE0, 0);
	else if (mode == SLEEP_MODE)		modify_bit(CANCTRL, 0xE0, (1<<REQOP0));
	else if (mode == LOOPBACK_MODE)		modify_bit(CANCTRL, 0xE0, (1<<REQOP1));
	else if (mode == LISTEN_ONLY_MODE)	modify_bit(CANCTRL, 0xE0, (1<<REQOP0) | (1<<REQOP1));
	else if (mode == CONFIGURATION_MODE)modify_bit(CANCTRL, 0xE0, (1<<REQOP2));
	else ;
} //void set_operating_mode(uint8_t mode)


//////////////////////////////////////////////////////////////////////////
////////////////////////////////Obsluha///////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void MCP2515::write_register(uint8_t adress, uint8_t data)
{
	spi.select(true);
	
	spi.write_data(SPI_WRITE);
	spi.write_data(adress);
	spi.write_data(data);
	
	spi.select(false);
} //void write_register(uint8_t adress, uint8_t data)

uint8_t MCP2515::read_register(uint8_t adress)
{
	uint8_t data;
	
	spi.select(true);
	
	spi.write_data(SPI_READ);
	spi.write_data(adress);
	
	data = spi.write_and_read_data(0xff);
	
	spi.select(false);
	
	return data;	
} //uint8_t read_register(uint8_t adress)

void MCP2515::modify_bit(uint8_t adress, uint8_t mask, uint8_t data)
{
	spi.select(true);
	
	spi.write_data(SPI_BIT_MODIFY);
	spi.write_data(adress);
	spi.write_data(mask);
	spi.write_data(data);
	
	spi.select(false);
} //void modify_bit(uint8_t adress, uint8_t mask, uint8_t data)

uint8_t MCP2515::read_status(uint8_t type)
{
	uint8_t data;
	
	spi.select(true);
	
	spi.write_data(type);
	data = spi.write_and_read_data(0xff);
	
	spi.select(false);
	
	return data;
} //uint8_t read_status(uint8_t type)

uint8_t MCP2515::read_rx_status(void)
{
	uint8_t data;
	
	spi.select(true);
	
	spi.write_data(SPI_RX_STATUS);			//Pozadavek na status
	data = spi.write_and_read_data(0xff);	//Precteni RX statusu
//spi.write_data(0xff);						//MCP2515 porad posila status bajt
	
	spi.select(false);
	
	//return ((~data) & 0x20);	//Vymaskovani spravneho bitu
	//return ((~data) & 0x02);
	return data;
} //uint8_t read_rx_status(void)


void MCP2515::reset()
{
	spi.select(true);
	spi.write_data(SPI_RESET);
	wait_ms(1);
	spi.select(false);
	wait_ms(50);
}

void MCP2515::rx_handler(fifo<can_message> &rx_buffer)
{
	uint8_t buffer_1[14];
	uint8_t buffer_2[14];

	buffer_1[0] = 0;
	buffer_2[0] = 0;

	//////////////////////////////////////////////////////
	//Co je v bufferu?
	//[   0	  ] - new message flag
	//[  1-4  ]	- id
	//[   5   ]	- length
	//[  6-13 ] - data
	//////////////////////////////////////////////////////


	uint8_t rx_status = read_rx_status();

	//Přečtení RX_BUFF_0, pokud je plný
	if (bit_is_set(rx_status,6))	//Zprava v bufferu 0
	{
		spi.select(true);
		spi.write_data(SPI_READ_RX_BUFF_0);

		buffer_1[0] = 1;

		for (uint8_t i=1;i<14;i++)
		{
			buffer_1[i] = spi.write_and_read_data(0xff);
		}

		spi.select(false);
	}

	//Přečtení RX_BUFF_2, pokud je plný
	if (bit_is_set(rx_status,7)) //Zprava v bufferu 1
	{
		spi.select(true);
		spi.write_data(SPI_READ_RX_BUFF_2);

		buffer_2[0] = 1;

		for (uint8_t i=1;i<14;i++)
		{
			buffer_2[i] = spi.write_and_read_data(0xff);
		}

		spi.select(false);
	}

	//Vytvoření a uložení can_message
	if (buffer_1[0])
	{
		can_message message;

		message.id  = 0;
		message.id |= buffer_1[1]<<3;
		message.id |= buffer_1[2]>>5;
		message.lenght = buffer_1[5];

		for(uint8_t i=0; i<message.lenght; i++)
		{
			message.data[i] = buffer_1[6+i];
		}

		rx_buffer.add(message);
	}

	if (buffer_2[0])
	{
		can_message message;
		message.id = (uint16_t)(buffer_2[1]<<8) | (uint16_t)(buffer_2[2]>>5);
		message.lenght = buffer_2[5];
		for(uint8_t i=0; i<message.lenght; i++)
		{
			message.data[i] = buffer_2[i];
		}

		rx_buffer.add(message);
	}
}

void MCP2515::tx_handler(fifo<can_message> &tx_buffer)
{
	//TODO: buffer priority

	while (tx_buffer.check())
	{
		uint8_t reg_sidh, reg_sidl, reg_dlc, reg_data, reg_rts;

		//Vybrání odesílacího bufferu
		if ( !(read_register(TXB2CTRL) & (1<<TXREQ)) )
		{
			reg_sidh = TXB2SIDH;
			reg_sidl = TXB2SIDL;
			reg_dlc  = TXB2DLC;
			reg_data = TXB2D0;
			reg_rts  = SPI_RTS_TXB2;
		}

		else if ( !(read_register(TXB1CTRL) & (1<<TXREQ)) )
		{
			reg_sidh = TXB1SIDH;
			reg_sidl = TXB1SIDL;
			reg_dlc  = TXB1DLC;
			reg_data = TXB1D0;
			reg_rts  = SPI_RTS_TXB1;
		}

		else if ( !(read_register(TXB2CTRL) & (1<<TXREQ)) )
		{
			reg_sidh = TXB0SIDH;
			reg_sidl = TXB0SIDL;
			reg_dlc  = TXB0DLC;
			reg_data = TXB0D0;
			reg_rts  = SPI_RTS_TXB0;
		}

		else
		{
			return; //TODO: Tady by to mohlo něco dělat, teoreticky už nemusí (přemístění message)
		}

		can_message message = tx_buffer.read();	//TODO: dynamic alocation

		//Zapsání ID
		write_register(reg_sidh, (uint8_t) (message.id>>3));
		write_register(reg_sidl, (uint8_t) (message.id<<5));

		//Zapsání délky zprávy
		write_register(reg_dlc, message.lenght);

		//Zapsání dat
		for (uint8_t i=0; i<message.lenght; i++)
		{
			write_register(reg_data+i, message.data[i]);
		}

		//Odeslání na sběrnici
		spi.select(true);

		spi.write_data(reg_rts);

		spi.select(false);
	}
}
