
#include "adc.h"
#include <avr/io.h>
#include <stdint.h>

// default constructor
adc_class::adc_class()
{
} //adc

// default destructor
adc_class::~adc_class()
{
} //~adc


//////////////////////////////////////////////////////////////////////////
/////////////////////////////Inicializace/////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void adc_class::set_reference_voltage(reference_voltages reference_voltage)
{
	ADMUX &= ~((1<<REFS1) | (1<<REFS0));
	ADMUX |= reference_voltage;
} //void set_reference_voltage(uint8_t _reference)

void adc_class::set_result_aligment(result_alignment alignment)
{
	if (alignment == LEFT) ADMUX |=  (1<<ADLAR);
	else				   ADMUX &= ~(1<<ADLAR);
} //void set_result_aligment(uint8_t _aligment)

void adc_class::set_prescaler(prescalers prescaler)
{
	ADCSRA &= ~((1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0));
	ADCSRA |= prescaler;
} //void set_prescaler(uint8_t _prescaler)

void adc_class::enable_free_running_mode()
{
	ADCSRA |= (1<<ADFR);
} //void enable_free_running_mode()

void adc_class::disable_free_running_mode()
{
	ADCSRA &= ~(1<<ADFR);
} //void disable_free_running_mode()

void adc_class::enable_adc()
{
	ADCSRA |= (1<<ADEN);
} //void enable_adc()

void adc_class::enable_adc(bool status)
{
	if (status) ADCSRA |=  (1<<ADEN);
	else 		 ADCSRA &= ~(1<<ADEN);
} //void enable_adc(bool _status)

/*
#ifndef __AVR_ATmega8__
void adc_class::enable_auto_trrigger()
{
	ADCSRA |= (1<<ADATE);
} //void enable_auto_trrigger()

void adc_class::enable_auto_trrigger(bool _status)
{
	switch (_status)
	{
		case true:	ADCSRA |=  (1<<ADATE);
			break;
			
		case false:	ADCSRA &= ~(1<<ADATE);
			break;
			
		default:	ADCSRA |=  (1<<ADATE);
			break;
	}
} //void enable_auto_trrigger(bool _status)
#endif
*/

void adc_class::enable_interrupt()
{
	ADCSRA |= (1<<ADIE);
} //void enable_interrupt()

void adc_class::enable_interrupt(bool _status)
{
	if (_status) ADCSRA |=  (1<<ADIE);
	else		 ADCSRA &= ~(1<<ADIE);
} //void enable_interrupt(bool _status)


//////////////////////////////////////////////////////////////////////////
////////////////////////////////Obsluha///////////////////////////////////
//////////////////////////////////////////////////////////////////////////

void adc_class::start_conversion()
{
	ADCSRA |= (1<<ADSC);
} //void start_conversion()

void adc_class::set_channel(channels channel)
{
	ADMUX &= ~((1<<MUX3) | (1<<MUX2) | (1<<MUX1) | (1<<MUX0));
	ADMUX |= channel;
} //void set_channel(uint8_t _channel)

bool adc_class::read_interrupt_flag()
{
	return (bool)(ADCSRA & (1<<ADIF));
} //uint8_t read_interrupt_flag()

uint16_t adc_class::read_adc()
{
	start_conversion();
	while (ADCSRA & (1<<ADSC));
	
	return ADC;
} //uint16_t read_adc()

uint16_t adc_class::read_adc(channels channel)
{
	set_channel(channel);
	
	return read_adc();
} //uint16_t read_adc(uint8_t _channel)
