#include "../external_interrupt.h"

#include <avr/io.h>

namespace extern_irq
{
	void enable(ext_interrupts interrupt)
	{
        EIMSK |= (1<<interrupt);
	}

	void disable(ext_interrupts interrupt)
	{
        EIMSK &= ~(1<<interrupt);
	}

    void set_sense(ext_interrupts interrupt, irq_senses mode)
    {
        if (interrupt <= INT3)
        {
            EICRA &= ~(3<<(interrupt*2));
            EICRA |= (mode<<(interrupt*2));
        }

        else
        {
            EICRB &= ~(3<<((interrupt-4)*2));
            EICRB |=  (3<<((interrupt-4)*2));
        }
    }
} //namespace extern_irq
