#pragma once

#ifndef _EXTERNAL_INTERRUPT_H_
# error "Include external_interrupt.h instead of this file"
#endif

#include <stdint.h>

#undef INT0
#undef INT1
#undef INT2
#undef INT3
#undef INT4
#undef INT5
#undef INT6
#undef INT7

namespace extern_irq
{
	enum ext_interrupts
    {
        INT0,
        INT1,
        INT2,
        INT3,
        INT4,
        INT5,
        INT6,
        INT7
    };

    enum irq_senses
	{
		low_level		= 0,
		logic_change	= 1,
		fallin_edge		= 2,
		rising_edge		= 3
	};

    extern void enable(ext_interrupts interrupt);
    extern void disable(ext_interrupts interrupt);
    extern void set_sense(ext_interrupts interrupt, irq_senses mode);
} //namespace extern_irq
