#pragma once

#ifndef _EXTERNAL_INTERRUPT_H_
# error "Include external_interrupt.h instead of this file"
#endif

#include <stdint.h>

namespace extern_irq
{
	enum interupt_sense
	{
		low_level		  = 0,
		logic_change	= 1,
		fallin_edge		= 2,
		rising_edge		= 3
	};

	extern void enable_INT0(void);
	extern void enable_INT0(bool status);

	extern void enable_INT1(void);
	extern void enable_INT1(bool status);

	extern void enable_INT2(void);
	extern void enable_INT2(bool status);

	extern void INT0_sense(uint8_t mode);
	extern void INT1_sense(uint8_t mode);
	extern void INT2_sense(uint8_t mode);	//only rising & falling edge
} //namespace extern_irq
