#include "../external_interrupt.h"

#include <avr/io.h>

namespace extern_irq
{
	//Enable external interupt
	void enable_INT0(void)
	{
		GICR |= (1<<INT0);
	} //void enable_INT0(void)

	void enable_INT0(bool status)
	{
		switch (status)
		{
			case true: GICR |= (1<<INT0);
				break;

			case false: GICR &= ~(1<<INT0);
				break;

			default: GICR |= (1<<INT0);
				break;
		}
	} //void enable_INT0(bool status)

	void enable_INT1(void)
	{
		GICR |= (1<<INT1);
	} //void enable_INT1(void)

	void enable_INT1(bool status)
	{
		switch (status)
		{
			case true: GICR |= (1<<INT1);
				break;

			case false: GICR &= ~(1<<INT1);
			break;

			default: GICR |= (1<<INT1);
				break;
		}
	} //void enable_INT1(bool status)

/*
	void enable_INT2(void)
	{
		GICR |= (1<<INT2);
	} //void enable_INT2(void)

	void enable_INT2(bool status)
	{
		switch (status)
		{
			case true: GICR |= (1<<INT2);
				break;

			case false: GICR &= ~(1<<INT2);
				break;

			default: GICR |= (1<<INT2);
				break;
		}
	} //void enable_INT2(bool status)
*/

	//Sense control
	void INT0_sense(uint8_t mode)
	{
		switch (mode)
		{
			case low_level:		MCUCR &= ~(1<<ISC01);
								MCUCR &= ~(1<<ISC00);
				break;

			case logic_change:	MCUCR &= ~(1<<ISC01);
								MCUCR |=  (1<<ISC00);
				break;

			case fallin_edge:	MCUCR |=  (1<<ISC01);
								MCUCR &= ~(1<<ISC00);
				break;

			case rising_edge:	MCUCR |=  (1<<ISC01);
								MCUCR |=  (1<<ISC00);
				break;

			default:			MCUCR &= ~(1<<ISC01);
								MCUCR &= ~(1<<ISC00);
				break;
		}
	} //void INT0_sense(uint8_t mode)

	void INT1_sense(uint8_t mode)
	{
		switch (mode)
		{
			case low_level:		MCUCR &= ~(1<<ISC11);
								MCUCR &= ~(1<<ISC10);
				break;

			case logic_change:	MCUCR &= ~(1<<ISC11);
								MCUCR |=  (1<<ISC10);
				break;

			case fallin_edge:	MCUCR |=  (1<<ISC11);
								MCUCR &= ~(1<<ISC10);
				break;

			case rising_edge:	MCUCR |=  (1<<ISC11);
								MCUCR |=  (1<<ISC10);
				break;

			default:			MCUCR &= ~(1<<ISC11);
								MCUCR &= ~(1<<ISC10);
				break;
		}
	} //void INT1_sense(uint8_t mode)

/*
	void INT2_sense(uint8_t mode)
	{
		enable_INT2(false);
		GIFR |= (1<<INTF2);

		switch (mode)
		{
			case rising_edge: MCUCSR &= ~(1<<ISC2);
				break;

			case fallin_edge: MCUCSR |=  (1<<ISC2);
				break;

			default:		  MCUCSR &= ~(1<<ISC2);
				break;
		}

		enable_INT2(true);
	} //void INT2_sense(uint8_t mode)
*/

} //namespace extern_irq
