#pragma once

#include <stdint.h>
#include "cplusplus.h"

template <typename A_type> class fifo
{
	private:
		enum settings
		{
			QUEUE_LENGHT	= 20
		};

		//Pole a další
		A_type queue[QUEUE_LENGHT];
		uint16_t read_position;
		uint16_t write_position;


	public:

		//Konstruktor, destruktor
		fifo();
		~fifo();

		//Metody pro operace s polem dat
		void add(A_type &data);

		A_type read();
		uint8_t check();
};

template <typename A_type> fifo<A_type>::fifo():read_position(0),write_position(0)
{

}

template <typename A_type> fifo<A_type>::~fifo()
{

}

template <typename A_type> void fifo<A_type>::add(A_type &data)
{
	queue[write_position++] = data;

	if (write_position > QUEUE_LENGHT-1) write_position = 0;
}

template <typename A_type> A_type fifo<A_type>::read()
{
	A_type value = queue[read_position++];

	if (read_position > QUEUE_LENGHT-1) read_position = 0;
	return value;
}

template <typename A_type> uint8_t fifo<A_type>::check()
{
	if (write_position < read_position)	return (QUEUE_LENGHT + write_position - read_position);
	else return (write_position - read_position);
}
