
#pragma once

#include <stdint.h>

#include "gpio.h"

class SHT11
{
	public:
	//Definice
		enum commands
		{
			TEMPERATURE		 = 0x03,
			HUMIDITY		 = 0x05,
			READ_STATUS_REG  = 0x07,
			WRITE_STATUS_REG = 0x06,
			SOFT_RESET		 = 0x1E
		};

	public:
	//Instance
		io *sda;
		io *sck;

	//Measuring stuff
		int16_t temp_raw;
		int16_t humi_raw;
		float temperature;
		float humidity;
		bool measuring_temp;
		bool measuring_humi;
		bool temp_done;
		bool humi_done;


	//Metody
		void start_tx();
		void send_command(commands command);
		uint16_t read_data();
		void stop_tx();

	public:
		SHT11(io *sda, io *sck);

		void initialize();
		bool check_communication();
		void communication_reset();
		void reset();

		uint16_t measure_temperature();
		uint16_t measure_humidity();

		void start_measuring_temperature();
		void start_measuring_humidity();

		void handler();

		float get_temperature();
		float get_humidity();

		uint8_t read_status_regster();
		void write_status_register();
};
